﻿#Change Log

##Version 3.9

####Changed Linker to Account for Array - 11/29/2013
+ linker.index can now be string or array of paths to attach links and scripts to.
	+ If array is specified each path in array will attach all scripts not specified with specific view.
	+ This particularly helpful in Single Page Apps where you might need a couple html files to contain all scripts and styles. e.g. using AngularJs.
+ Fixed issue where grunt.json would output 'http' CDN paths with prefix path.
+ Updated relations.js fixup for jugglingDB.


##Version 3.8

####Error Handling for Juggling Validation Codes - 11/26/2013
+ Changed error trace to include validation codes in object.
+ Updated actions to support new custom error DatabaseValidationError.
+ Added _errors to globals so that you can do new _errors.DatabaseValidationError(null, codes)
	+ Where codes would be the codes in the error after checking model.valid(function (valid) { var codes = model.errors });


##Version 3.7

####Routing, Null Properties Prune - 11/18/2013
+ Additional routing fixes.
+ Added option for auto defined routes to prune empty or null properties.
	+ This is helpful where id fields or relational id fields might get passed in and cause validation error.
+ Misc performance improvements.
+ Updated System Locals. **res.locals.system** contains common system related params.

##Version 3.6

####Major Refactor of Linker.js - 10/29/2013
+ Solved issue where REST request were not properly detected in handlers.
+ **IMPORTANT** changed config structure slightly.
	+ Moved authentication config under handlers.security.
	+ Refactored Error, Security and FNF handler to better handle custom paths and simple redirects.
	+ Changed linking. Removed auto linking of Angular/jQuery/Less.
		+ All linking is done via linker.js which better allows for better ordering. Originally Less, Angular, jQuery CDN's were automatically added to the linker configuration behind the scenes. This made it difficult to order things and why we don't auto add scripts and styles that get minified and copied to your public directory.

##Version 3.5

####Juggling DB Object Instance Fix- 10/23/2013
+ Fixed issue where hook callbacks passed plain object instead of jugglingdb instance.
+ Fixed problem where security could fail on some routes.
+ Resolved issue where delete methods were not properly routed.
+ Corrected problem where "updates" would create a duplicate instead of updating.

##Version 3.4

####Fixed Routing, added Relations Fixup - 10/10/2013
+ Fixed issue where puts could cause a POST instead.
+ Added fixup for jugglingdb relations.js where id's could not match equality when using mongodb.

##Version 3.3

####Seeding, Boolean Fixup - 10/10/2013
+ Updated sqlite3 and memory adapters to better handle Booleans.
+ Fixed issue where Boolean default value could get set to NULL instead of actual value.
+ Added option in app.js to turn off seeding globally so each model doesn't need to be set to false.
	+ example: in app.js set allowSeeds: false
	+ seeding is still disabled in production mode to prevent overwriting real/valid data.
+ Resolved issue where dot notation and handle lookup failed due to change of method name.

##Version 3.2

####Enhancements Routing Fix - 10/8/2013
+ Misc code improvements and performance enhancements.
+ Fixed issue where multiple routes to same route but different methods were overwritten.

##Version 3.1

####Security Handler, Juggline Schema Text/Json - 9/18/2013
+ Changed security handler to better handing authentication schemes.
+ Framework.js updated to handle ORM datatypes Schema.Text and Schema.JSON
	+ To define property as type Schema.Text or Schema.JSON set type as 'Text' or 'JSON' (case sensitive)
+ Made some internal helpers now public globals. Use _helpers to access.
+ Updated templates and seeds with minor fixes. Models template now stubs out callbacks.
+ Added option to assign property as hidden so as not to display when using REST json. For example a password hash field.
	+ Set property in model as propertyName: { type: String, hidden: true }
	+ Note this only works automatically in auto generated routes. If you wish to uses this in a controller manually use global _helpers.trimModel(model, xModel) where "xModel" is the name of your defined model (the string name) or the xModel object itself.

##Version 3.0

####Updated Grunt Clean & Templating - 9/14/2013
+ Adjusted Grunt Clean and removed it from production task.
+ Added better error handling for validation errors thrown by jugglingdb.
+ Added example for extending model with validation/relationships. 
+ Generation templates also include stubbed out extend property for validations and relationships.

##Version 2.9

####REST Routing Fix - 9/13/2013
+ Modified view templates.
+ Changed handlers to better route in RESTful requests.
+ Misc framework changes(minor).
+ Less output CSS/JS directories now clean before output.

##Version 2.7

####Globals, Version Check, Angular Refactor - 9/7/2013
+ Several changes to better serve AngularJs.
+ Updated handler for exposing globals.
+ Exposed globals (NOTE: you can also set any object in the Xipframe instance to be exposed by setting the "globals" object in your /config/app.js confguration.
	+ \_log - exposes Winston logger and custom reader.
		+ logging - example: _log.warn('my error', metadata) where metadata is an object.
		+ reading - example: _log.reader(callback) returns array of logged objects.
	+ \_diskio - is a helper class to assist in file input output operations.
	+ \_ - single underscore which exposes [lodash](http://lodash.com/)
	+ \_models - exposes all of your defined jugglingdb schema models.
+ Update seeds
+ Gruntfile.js updated for AngularJs tasks.
+ apps.json now check for Xipframe version, now requires "xipframe start -f" if version mismatch is detected to upgrade.

##Version 2.6

####AngularJs Refactoring - 9/3/2013
+ Removed Cluster support due to reported issues. Refactored, but pushing out to ver. 0.3.5
+ Refactored AngularJs setup. Created basic initial structure. Added initial controller and changed extension to .html when Angular is enabled. Initial index page rendered as ejs, so intial models can be passed if needed.
+ Changed AngularJs folder inside "client". **MOVED** to /client/angular instead of /client/public/angular. Makes Angular routing a little less verbose. Made more sense.

##Version 2.5

####Added Cluster Support - 9/1/2013
+ Added cluster support. default set to fault. enable in /config/app.js "cluster: true". Only active when in production mode.

##Version 2.4

####Preview to Mobile Export - 9/1/2013
+ Framework preview where app can be packaged as mobile for installing/deploying via cordova.
+ Fixed issue where installing with Angular or Less flags could throw error.

##Version 2.3

####Error Killing Child - 9/1/2013
+ Resolved issue where killing child processes threw error.

####Override, GruntFile - 8/31/2013
+ Add ability to override gloally using override.json file. Good when using Xipframe to host multiple applications and need to globally ensure certain config properties are maintained. 
+ Disable watching of css when running in production mode.

## Version 2.2

####Linux Install Issue - 8/28/2013
+ Fixed problem with UTF-8 BOM when dev on windows and bundling package.

####CSS Styles Not Linked - 8/27/2013
+ CSS styles not linking and properly applying when LESS is enabled. Changed names to avoid conflict

