
[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/logo.png">](http://www.xipframe.com)

[![Build Status](https://travis-ci.org/chazelton/xipframe.png?branch=master)](https://travis-ci.org/chazelton/xipframe) [![NPM version](https://badge.fury.io/js/xipframe.png)](http://badge.fury.io/js/xipframe)

##MVC Framework for Node/Express

**LINKER REFACTOR** The linker feature has been refactored significantly. You will be required to run xipframe start -f as usual when upgrading. This will create a backup copy of your linker.js as well as Gruntfile.js. You will likely need to re-organize the order of your scripts and styles within the linker.js file after the first build. Once this is done the linker will preserve the order. See the change log for new features in linker.js.

[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/linker.PNG" width="600">](https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/linker.PNG)

**RE-WRITE** Xipframe is being rewritten based on feedback and testing. The current flavor was a quickly thrown together framework to see what works, what doesn't. Best practices were some times skipped in favor of expediting release. We are rewriting the framework from this experience. Much of the logic and naming conventions will stay the same however there will be NO upgrade path to version 1.0.0 once released. Also note version 1.0 will come with a full testing framework. **If you have suggestions or wants now is the time...mail origin1tech@gmail.com**

**SOME FEATURES MAY NOT BE FUNCTIONAL IN THIS DEVELOPMENTAL FRAMEWORK. VERSION 1.0.0 WILL BE THE FIRST OFFICIAL RELEASE. UNTIL THEN XIPFRAME IS NOT GUARANATEED TO BE FULLY FUNCTIONAL.**

###Change Log
[view change log](https://github.com/chazelton/xipframe/blob/master/CHANGELOG.md)

###Important

In the "fixups" folder there are several fixes for jugglingdb adapaters which Xipframe depends on. If for any reason your framework breaks after updating just do:

    xipframe start -f

###Video Tutorials

[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/play.jpg">](http://www.youtube.com/watch?v=bVsEADCZKD4) - **Installation**

[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/play.jpg">](http://www.youtube.com/watch?v=Y0vCEsZ4g2M) - **Models**

[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/play.jpg">](http://www.youtube.com/watch?v=JcNlTWPly9A) - **Controllers**

[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/play.jpg">](http://www.youtube.com/watch?v=M0i-tfiUS18) - **Models, Controllers & Globals**

[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/play.jpg">](http://www.youtube.com/watch?v=382Rt5NgCoE) - **Model Validations & Relationships**

[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/play.jpg">](http://www.youtube.com/watch?v=nyg6Nf_JeCo) - **Security & Policies**

[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/play.jpg">](http://www.youtube.com/watch?v=L6KY_ENSWeE) - **Handlers & Middleware**

[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/play.jpg">](http://www.youtube.com/watch?v=sKcTEC9q8yo) - **Adapters**

[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/play.jpg">](http://www.youtube.com/watch?v=rO-XsqGCOTM) - **Assets**

[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/play.jpg">](http://www.youtube.com/watch?v=2oH86mIWE_Y) - **Less & Themes**

[<img src="https://raw.github.com/chazelton/xipframe/master/seeds/client/public/img/play.jpg">](http://www.youtube.com/watch?v=ZVnwJaLucUo) - **Tips**


###Key Features

* Built in **AngularJS** seeding with a proven model that makes Angular references a snap.
* Enable **Less** for css easily and have it automatically compile to css.
* Built in **minification** folder that minifies via **Grunt**.
* Css minification and mixin folder that **automatically minifies** on build.
* Routes are compiled and routed through standard Express Router.
* Saves/Backsup key config info. 
* Install new apps with previous config file, very handy.
* Specify seed directory and template directories if not using default to have subsets of configurations for different styles of apps (e.g. REST vs. rendering views).
* **Globally accessibile xipframe object**.
* Advanced **logging** that nicely displays offending filename with col/line that's the culprit.

###Installing

**NOTE**: Windows users may experience difficulty installing using npm install. If so check that you have Python (no greater than 2.7) installed and that it is in your PATH. Also verify that Git is installed and also in your path.

**SETTING PATH** For instructions on setting path see => http://stackoverflow.com/questions/3701646/how-to-add-to-the-pythonpath-in-windows-7 and it should be self explanatory. Similar do the same for the Git installation path.

xipframe should be installed using the -g switch. This installs xipframe globally which is highly recommended.

    npm install xipframe -g

###Create/Install Application

Creating a new application is rather simple. Run the below command from the parent directory of your choosing. A sub folder will be created with the application by the name you specify.

    xipframe create appname

#####Create/Install Options

* -g  	installs application with AngularJS seeding.
* -l  	installs application with LESS for css styling.
* -c  	specify the path to the config to use during app creation. `-c "C:\path\to\your\conf.json"`
* -v  	specify the view engine to use. options are either "ejs" or "jade". others will be supported soon!!!
* -s  	specify the path to the seeds files directory to use during app creation. `-c "C:\path\to\your\seeds"`
* -t  	specify the path to the templates files directory to use during app creation. `-c "C:\path\to\your\templates"`

###Uninstalling

Nothing fancy about this just removes an application from xipframe and also deletes your application directory.

    xipframe uninstall appname

###Start Application

Again nothing difficult here. xipframe will look for the application in the current directory and start it. xipframe is able also to start an application from any current directory that you might be in. This is because it tracks applications hence it know's the install path. This is experiental and may be removed at some point if not found to be viable.

    xipframe start

You may also from any directory start an application by name. This is because unlike other frameworks xipframe stores applications and their related paths.

    xipframe start appname

When you've successfully started your application you'll see something similar to the below.

____
Xipframe Started
____

 * > Application <APP_NAME> powered by Xipframe running.
 * > Host: 0.0.0.0  Port: 1337 Environment: development
 * > View your application at --> http://0.0.0.0:1337

###Coming Soon!

In short a lot more including documentation using jsdoc as well as wiki and so on. The source is very heavily commented so if you're an Express/Node guy you should have little trouble determining what's going on. Until then if you're interested in following the development of this framework the comments should get you by in the meantime.

##License

Xipframe MVC Framework for NodeJs and Express. GPLv3

Copyright (C) 2013  Origin1 Technologies

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see http://www.gnu.org/licenses/.