

/**
* Expose globals to application.
*
* @module globals
* @param {object} xipframe - loaded xipframe instance.
*/
module.exports = function globals(xipframe) {

    'use strict';

    var _ = xipframe.utils._
      , helpers = xipframe.utils.helpers;

    return function exposeGlobals(_global) {

        _.forEach(xipframe.config.globals, function (val, key) {
            
            var obj = null
              , keys = val.split('.')
              , len = keys.length;          
         
            if (len === 0) {
                obj = xipframe[keys[0]];
            } else {       
                obj = helpers.getPropertyByName(xipframe, val);         
            }            

            if (obj) _global[key] = obj;

        });

    };

};
