
/**
* Manually removes an app from apps.json.
* @module remove
* @param {object} appName - the name of the app set for removal.
* @param {object} xipframe - the loaded Xipframe instance.
*/
module.exports = function (appName, xipframe) {

    'use strict';

    var appdate, apps, app, UninstallError, appPath;
    appdate = xipframe.utils.appdate,
    apps = xipframe.config.apps,
    app = apps[appName],
    UninstallError = xipframe.errors.UninstallError;
    appPath = app && app.paths && app.paths.app ? app.paths.app : 'Unknown';


    if (!app) throw new UninstallError('Application NOT installed or does NOT exist at "' + appPath + '".');
    
    delete apps[app.appName];
    appdate.save(xipframe.config, true);

    console.log(' > ' + app.appName + ' successfully removed from apps.json');

};
