
/**
* Cluster manager.
*
* TODO: future implementation
*
* @module cluster
* @returns {function}
*/

exports.buildWorkers = function buildWorkers(xipframe) {

    'use strict';

    var cluster = require('cluster')
      , cpus = require('os').cpus()
      , config = xipframe.config;


        if (cluster.isMaster) {

            /* master process */
            console.log(' > Cluster master process: ' + process.pid + ' running.');

            /* fork our cpus */
            for (var i = 0; i < cpus.length; i++) {

                cluster.fork();

            }

            /* handle workers on exit */
            cluster.on("exit", function(worker, code) {

                if (code != 0) {
                    console.log('warn', 'Worker: ' + worker + 'exited...re-spawning.');
                    cluster.fork();
                }

            });

            /* reload workers */
            process.on("SIGUSR2", function() {

                var i, workers, func, newWorker;

                console.log('SIGUSR2 received worker reload in process.');

                /* delete require cache so we can reload */
                //delete require.cache[require.resolve('./xipframe')];

                /* load one worker at a time */
                i = 0;
                workers = Object.keys(cluster.workers);

                func = function () {

                    if (i == workers.length) return;

                    console.log(' > Shutting down worker ' + workers[i]);

                    cluster.workers[workers[i]].disconnect();

                    cluster.workers[workers[i]].on("disconnect", function() {
                        console.log(' > Worker successfully shutdown.');
                    });

                    newWorker = cluster.fork();
                    newWorker.on("listening", function() {

                        console.log(' > New worker online.');
                        i++;
                        func();

                    });
                };

                func();

            });

        } else {

            xipframe.start();

        }

  
};
