/**
* Override config which overrides any user defined properties.
* @module override
* @param {object} xipframe - the loaded instance of Xipframe.
* @returns {function}
*/
module.exports = function override(xipframe) {

    'use strict';

    var utils = xipframe.utils
      , _ = utils._;

    /**
    * Override object
    * @function overrideObject
    * @object mergeConfig - will be merged into override.json. rarely used here for good measure.
    * @augments override
    * @returns {object}
    */
    return function overrideObject(mergeConfig) {
        
        mergeConfig = mergeConfig || {};
        
        var config = {}
          , overrideExists = utils.diskio.existsSync(xipframe.config.paths.override);

        if (overrideExists) {
            config = utils.package.get(xipframe.config.paths.override);
            if (config) _.merge(config, mergeConfig);
        }

        /* nothing to do but return the mergeConfig in case something was passed. */
        return config || mergeConfig;
        
    };

};
