
/**
* Shutdown on signal.
*
* @module shutdown
* @param {object} xipframe - the loaded Xipframe instance.
* @returns {function}
*/
module.exports = function shutdown(xipframe) {

    'use strict';

    return function shutdownEvents() {

        process.on('SIGINT', function() {
            xipframe.shutdown(process.exit);
        });
        
        process.on('SIGTERM', function() {
            xipframe.shutdown(process.exit);
        });
        
        process.on('exit', function() {
            if (!xipframe.exiting) xipframe.shutdown(process.exit);
        });

    };


}
