﻿
/**
* @file defines adapters.
*/
module.exports = {

    // supported adapters => '<%- adapters.supported %>'                                

    active: '<%= adapters.active %>',                                       // active adapter name must match a configuration below. memory adapter does not require any settings.
                                                            
    mongodb: {
        module: 'jugglingdb-mongodb'                                // the name of the adapter module.
        , database: '<%= appName %>'                                  // database name typically name of your application.
        , host: 'localhost'                                           // the host to connect to.
        , port: 27017                                                 // the port to use null or comment out.
        , username: null                                              // authorized username, null or comment out.
        , password: null                                              // authorized password, null or comment out.
        //, url: ''                                                   // if used overrides above settings, use for more complex custom connections.
    },


    redis: {
        module: 'jugglingdb-redis'                                 // the name of the adapter module.
        , host: 'localhost'                                          // host to connect to such as localhost.
        , port: 6379                                                 // default used if commented.
        , password: null                                             // null or comment out.
        , options: {}                                                // redis options.
        // , url: ''                                                 // if used overrides above settings, use for more complex custom connections.
    },

    sqlite3: {
        module: 'jugglingdb-sqlite3'
        , database: '/db/<%= appName %>.db'                              // either :memory: or db path.
        , scheme: 'autoupdate'                              // autoupdate or null.
    },

    mysql: {
        module: 'jugglingdb-mysql'
        , database: '<%= appName %>'
        , host: 'localhost'
        , port: 3306
        //, timezone: ''
        //, socketPath: ''
        //, collation: ''
        //, supportBigNumbers: true
        //, debug: true
        , username: null
        , password: null
        , scheme: 'autoupdate'                              // either autoupdate or automigrate.
    }

};