﻿
/**
* @file overrides security settings.
* @see {@link file:middleware|name} description.
*/
module.exports = {

    /* Security policies allow you to restrict access
    * to your application either globally or by controller
    * and action. See below example where "User" is defined 
    * with various permisions per action.
    *
    * NOTE: the default policy allows all traffic!!!!
    *
    * [GLOBAL SECURITY POLICY] '*' is required and must a have a value. 
    * SET TRUE - all traffic is allowed unless controller/action specific policies are specified.
    * SET FALSE - requires all requests to be authenticated before hitting any controller/action specified policies.
    * SET CALLBACK - if you set the global policy to a callback e.g. security middleware in your "framework/security" it will be handled
    * prior to any controller/action specified policies.
    */

    '*': true                                               


  //, User: {
  //    '*': 'authenticated',                                 // Allows all that have an authenticated session to call any action that doesn't explicity have a policy defined.
  //    find: true,                                           // Allows finding by anonymous.
  //    findAll: false                                        // Denies finding all by anonymous.
  //  }

};   