﻿
/**
* @file overrides session settings.
*/
module.exports = {

    // NOTE: specify an adapter as the same name as your application to use the same connection.
    // for example if you are using the mongodb adapter for your database and wish to use the same for
    // your session adapter simply set "adapter" to "mongodb" with no adapter settings specified. 

    // supported session adapters => <%= session.supported %>               

    adapter: '<%= session.adapter %>'                                         // the default adapter memory NOT suitable for production use and doesn't not require any settings.

    , secret: '<%= session.secret %>'                                         // the session secret this is backed up by Xipframe for you.

    , key: '<%= session.key %>'                                               // changing this can have adverse effects, make sure you know what you're doing. this is unique to your app and randomly created.

    //, maxAge: 1000 * 60 * 60 * 24                                           // set the expiry age for sessions.

    //, httpOnly: false                                                       // if false allows client side session cookies.

    , mongodb: {
          module: 'connect-mongo'                                             // see https://github.com/kcbanner/connect-mongo for full instructions.
         ,database: 'appname'                                                 // the database name to connect to typically your app name or perhaps appname-sessions 
         ,host: 'localhost'                                                   // the host or ip to connect to.
         ,port: null                                                          // the port to connect to. null connects to 27017
         ,username: null                                                      // username if applicable or null.
         ,password: null                                                      // password if applicable or null   
         ,collection: 'sessions'                                              // 'sessions' is the default unless you plan on changing the collection name no need to specify.                                                         
         ,url: ''                                                             // if provided overrides above settings.
    }

    , redis: {                                                                 // see https://github.com/visionmedia/connect-redis for full instructions.
          module: 'connect-redis'
         ,host: 'localhost'                                                    // the host or ip to connect to.
         ,port: '6379'                                                         // the port the redis server listens on.    
         ,password: 'your password'                                            // when connections require password.
         ,options: {}                                                          // see redis connection reference for options.
    }


};
