﻿
/**
* Handles errors for domain.
* @file errorHandler
*/
module.exports = function errorHandler(err, req, res, next) {

    /* 
    *  NOTE: You must enable in app.js use handlers: { error: false }
	*  This will cause Xipframe to hand off the error to your user defined
	*  error handler here instead of handling it internally.
    *
    *  Formatted error properties:
    *  err.message, err.name, err.metadata.stack, err.metadata.function, 
    *  err.metadata.stackStr, err.metadata.file, err.metadata.line, err.metadata.col.
    *
    *  Xipframe formats errors so that your stack strace is either a 
    *  string or an object for your needs. The stack object is not logged
    *  in the interest of more readable logs however the offending line, column
    *  file and function are all recored. If you'd like stack traces to be included
    *  in your logs in app.js simply include log: { trace: true }
    *
    */

    if (err) {

        /* render the error page */
        res.render('shared/error', { err: err });

    } else {

        /* no error just continue */
        next();

    }

    

}; 