﻿
/**
* @file overrides linker settings.
*
* NOTE: This file gets overwritten on each start of your application.
* your linked assets will be maintained however any comments or anything 
* marked up outside of index, enabled or files array will be destroyed.
*/
module.exports = {

    /*
    * Auto links attach your styles and script to your view 
    * all linked items are inserted into the specified view in the order in which they are
    * entered in the below files array.
    * STYLES are relative to the public folder
    * SCRIPTS are relative to the public folder
    * VIEWS are relative to the views folder

    * STYLE example: '/css/style.css'
    * SCRIPT example: '/js/myscript.js'
    * VIEW example: '/user/myview.ejs'

    * INDEX is the path to the main view where files will be linked.
    * in your files array you can specify a specific "view" which will overload the index path and link it to that view as an alternative.

    * Any other file you'd like linked to your views just specify in the files below using type custom. You can turn it on or off by setting enabled: false.
    * If you do not specify an enabled property it will default to true.

    * ENABLED - DOES NOT DISABLE Angular, Less or jQuery globally when toggled on or off for the respective script.
    * Rather it allows you to disable it in case you want to test a manual script that you might put on your view.
    * If you do not want to have Angular, Less or jQuery links created you'll need to disable the feature in your /config/app.js 
    * configuration file. 

    * ORDERING if you have enabled or disabled jQuery, Angular or Less from your app.js config you may need to reorder your scripts/styles below
    * in your desired order. There are too many variables as to what should load before or after a given script
    * hence you may have to play around with the order after the first build when you've made one of the 
    * described changes. 

    * options for files are 
    * { 
    *   type: 'css' (default = 'custom' for any object not specified)
    *   src: 'path to file', 
    *   view: 'path to view, (default = index property value below) 
    *   replace: 'some value' (value here will look for [REPLACE] in your source and replace it with this value, useful for versions)
    *   enabled: true  (default = true)
    * }
	*
    */

    index: [INDEX],                       

    enabled: [ENABLED],                   

    files: [
		[FILES] 
    ]                                                        
                                                       
};